using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace Gdi1
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// panel
			// 
			this.panel.BackColor = System.Drawing.SystemColors.Window;
			this.panel.Location = new System.Drawing.Point(104, 8);
			this.panel.Name = "panel";
			this.panel.Size = new System.Drawing.Size(300, 200);
			this.panel.TabIndex = 0;
			this.panel.Paint += new System.Windows.Forms.PaintEventHandler(this.panel_Paint);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(408, 213);
			this.Controls.Add(this.panel);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void panel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Rectangle rect = e.ClipRectangle;
			Graphics g = e.Graphics;
			Debug.WriteLine(
				String.Format("e.ClipRectangle: X = {0:d}, y = {1:d}, width = {2:d}, height = {3:d}", 
				rect.X, rect.Y, rect.Width, rect.Height));

			RectangleF rectF = g.VisibleClipBounds;
			Debug.WriteLine(
				String.Format("g.ClipBounds: X = {0:f}, y = {1:f}, width = {2:f}, height = {3:f}", 
				rectF.X, rectF.Y, rectF.Width, rectF.Height));
			float pageScale = g.PageScale;
			Debug.WriteLine(String.Format("pageScale = {0}, pageUnit {1}", 
				pageScale, g.PageUnit.ToString() ));

			Pen pen = new Pen(Color.Blue);

			/*
			g.DrawLine(pen, 40, 20, 200, 150);
			string label1 = "40, 20";
			string label2 = "200, 150";
			SolidBrush brush = new SolidBrush(Color.Red);
			g.DrawString(label1, this.Font, brush, 40, 20);
			g.DrawString(label2, this.Font, brush, 200, 150);
			*/

			// axis: origin at pixel coordinates 20, 100
			// x - axis
			g.DrawLine(pen, 15, 100, 280, 100);
			// y - axis
			g.DrawLine(pen, 20, 10, 20, 180);

			// plot a sinus function
			int ix, iy;
			int ixOld, iyOld;
			ixOld = xToDevice(0.0); 
			iyOld = yToDevice(0.0);
			double x = 0.0;	// pixel as double
			double y;
			while (x < 250.0)
			{
				y = 50.0*Math.Sin(x/10.0);
				ix = xToDevice(x);
				iy = yToDevice(y);
				g.DrawLine(pen, ixOld, iyOld, ix, iy);
				ixOld = ix;
				iyOld = iy;
				x += 1.0;
			}
		
		}

		// transform user coordinates to device coordinates (pixel)

		int xToDevice (double x)
		{
			return 20 + (int) x;	// origin + 10*x
		}

		// change y coordinates from bottom to top into top to bottom

		int yToDevice (double y)
		{
			return 200 - (100 + (int) y);
		}
	}
}
